国产xxxx99真实实拍_久久不雅视频_高清韩国a级特黄毛片_嗯老师别我我受不了了小说

資訊專欄INFORMATION COLUMN

LTMP手動(dòng)編譯安裝以及全自動(dòng)化部署實(shí)踐

The question / 1708人閱讀

摘要:我自己是從商業(yè)化環(huán)境走出來的,對(duì)于開源的部署方案也是在一點(diǎn)一點(diǎn)摸索,我相信其中也必然包含某些坑爹的配置。設(shè)置為表示當(dāng)經(jīng)常出現(xiàn)錯(cuò)誤時(shí)可以嘗試更改此選項(xiàng)。設(shè)置環(huán)境變量添加服務(wù)設(shè)置開機(jī)自動(dòng)啟動(dòng)服務(wù)配置其它擴(kuò)展都可以動(dòng)態(tài)添加,沒事的

前言

現(xiàn)在很多朋友都了解或者已經(jīng)在使用LNMP架構(gòu),一般可以理解為L(zhǎng)inux Shell為CentOS/RadHat/Fedora/Debian/Ubuntu/等平臺(tái)安裝LNMP(Nginx/MySQL/PHP),LNMPA(Nginx/MySQL/PHP/Apache),LAMP(Apache/MySQL/PHP)等類似的開發(fā)或生產(chǎn)環(huán)境。我自己是從SuSE/Oracle商業(yè)化環(huán)境走出來的,對(duì)于開源的部署方案也是在一點(diǎn)一點(diǎn)摸索,我相信其中也必然包含某些坑爹的配置。這篇文章較為詳細(xì)的描述了基于LTMP架構(gòu)的部署過程,之后會(huì)再考慮獨(dú)立各個(gè)模塊分享細(xì)節(jié)和技巧,如果大家有更合適的配置實(shí)踐手冊(cè)歡迎一起分享,文章中的錯(cuò)誤和改進(jìn)點(diǎn)也請(qǐng)幫忙指點(diǎn)下哈。

  

LTMP(CentOS/Tengine/MySQL/PHP)


更新歷史

2015年08月04日 - 初稿

閱讀原文 - http://wsgzao.github.io/post/ltmp/

擴(kuò)展閱讀

CentOS - http://www.centos.org/
Tengine - http://tengine.taobao.org/
Nginx - http://nginx.org/en/docs/
MySQL - http://www.mysql.com/
PHP - http://php.net/


LTMP版本

CentOS_6.5_64

Tengine-2.1.0

MySQL_5.6.25

PHP_5.5.27

Apache_2.2.31(醬油)

準(zhǔn)備工作
  

如果允許公網(wǎng)訪問會(huì)方便很多

bash#優(yōu)化History歷史記錄
vi /etc/bashrc

#設(shè)置保存歷史命令的文件大小
export HISTFILESIZE=1000000000
#保存歷史命令條數(shù)
export HISTSIZE=1000000
#實(shí)時(shí)記錄歷史命令,默認(rèn)只有在用戶退出之后才會(huì)統(tǒng)一記錄,很容易造成多個(gè)用戶間的相互覆蓋。
export PROMPT_COMMAND="history -a"
#記錄每條歷史命令的執(zhí)行時(shí)間
export HISTTIMEFORMAT="%Y-%m-%d_%H:%M:%S "

#設(shè)置時(shí)區(qū)(可選)
rm -rf /etc/localtime
ln -s /usr/share/zoneinfo/Asia/Shanghai /etc/localtime

#禁用NetworkManager(可選)
/etc/init.d/NetworkManager stop
chkconfig NetworkManager off
/etc/init.d/network restart

#關(guān)閉iptables(可選) 
/etc/init.d/iptables stop
chkconfig iptables off

#設(shè)置dns(可選)
echo "nameserver 114.114.114.114" > /etc/resolv.conf 

#關(guān)閉maildrop
#cd /var/spool/postfix/maildrop;ls | xargs rm -rf; 
sed "s/MAILTO=root/MAILTO=""/g" /etc/crontab
service crond restart

#關(guān)閉selinux
setenforce 0
sed -i "s/SELINUX=enforcing/SELINUX=disabled/" /etc/selinux/config  


#文件打開數(shù)量,
echo ulimit -SHn 65535 >> /etc/profile
source /etc/profile

#修改最大進(jìn)程和最大文件打開數(shù)限制
vi /etc/security/limits.conf
* soft nproc 11000
* hard nproc 11000
* soft nofile 655350
* hard nofile 655350

sed -i -e "/# End of file/i* soft  nofile 65535
* hard nofile 65535"  /etc/security/limits.conf

#優(yōu)化TCP
vi /etc/sysctl.conf

net.ipv4.ip_forward = 0  
net.ipv4.conf.default.rp_filter = 1  
net.ipv4.conf.default.accept_source_route = 0  
kernel.sysrq = 0  
kernel.core_uses_pid = 1  
#開啟SYN Cookies,當(dāng)出現(xiàn)SYN等待隊(duì)列溢出時(shí),啟用cookies來處理
net.ipv4.tcp_syncookies = 1  
kernel.msgmnb = 65536  
kernel.msgmax = 65536  
kernel.shmmax = 68719476736  
kernel.shmall = 4294967296  
#timewait的數(shù)量,默認(rèn)是180000
net.ipv4.tcp_max_tw_buckets = 6000  
net.ipv4.tcp_sack = 1  
net.ipv4.tcp_window_scaling = 1  
net.ipv4.tcp_rmem = 4096 87380 4194304   
net.ipv4.tcp_wmem = 4096 16384 4194304   
net.core.wmem_default = 8388608  
net.core.rmem_default = 8388608  
net.core.rmem_max = 16777216  
net.core.wmem_max = 16777216  
#每個(gè)網(wǎng)絡(luò)接口接收數(shù)據(jù)包的速率比內(nèi)核處理這些包的速率快時(shí),允許送到隊(duì)列的數(shù)據(jù)包的最大數(shù)目
net.core.netdev_max_backlog = 262144  
#web應(yīng)用中l(wèi)isten函數(shù)的backlog默認(rèn)會(huì)給我們內(nèi)核參數(shù)的net.core.somaxconn限制到128,而nginx定義的NGX_LISTEN_BACKLOG默認(rèn)為511,所以有必要調(diào)整這個(gè)值
net.core.somaxconn = 262144  
#系統(tǒng)中最多有多少個(gè)TCP套接字不被關(guān)聯(lián)到任何一個(gè)用戶文件句柄上。如果超過這個(gè)數(shù)字,孤兒連接將即刻被復(fù)位并打印出警告信息。這個(gè)限制僅僅是為了防止簡(jiǎn)單的DoS攻擊,不能過分依靠它或者人為地減小這個(gè)值,更應(yīng)該增加這個(gè)值(如果增加了內(nèi)存之后)     
net.ipv4.tcp_max_orphans = 3276800  
#記錄的那些尚未收到客戶端確認(rèn)信息的連接請(qǐng)求的最大值。對(duì)于有128M內(nèi)存的系統(tǒng)而言,缺省值是1024,小內(nèi)存的系統(tǒng)則是128
net.ipv4.tcp_max_syn_backlog = 262144  
#時(shí)間戳可以避免序列號(hào)的卷繞。一個(gè)1Gbps的鏈路肯定會(huì)遇到以前用過的序列號(hào)。時(shí)間戳能夠讓內(nèi)核接受這種“異常”的數(shù)據(jù)包。這里需要將其關(guān)掉
net.ipv4.tcp_timestamps = 0  
#為了打開對(duì)端的連接,內(nèi)核需要發(fā)送一個(gè)SYN并附帶一個(gè)回應(yīng)前面一個(gè)SYN的ACK。也就是所謂三次握手中的第二次握手。這個(gè)設(shè)置決定了內(nèi)核放棄連接之前發(fā)送SYN+ACK包的數(shù)量
net.ipv4.tcp_synack_retries = 1  
#在內(nèi)核放棄建立連接之前發(fā)送SYN包的數(shù)量
net.ipv4.tcp_syn_retries = 1  
#啟用timewait快速回收     
net.ipv4.tcp_tw_recycle = 1  
#開啟重用,允許將TIME-WAIT sockets重新用于新的TCP連接
net.ipv4.tcp_tw_reuse = 1  
net.ipv4.tcp_mem = 94500000 915000000 927000000   
#如果套接字由本端要求關(guān)閉,這個(gè)參數(shù)決定了它保持在FIN-WAIT-2狀態(tài)的時(shí)間。對(duì)端可以出錯(cuò)并永遠(yuǎn)不關(guān)閉連接,甚至意外當(dāng)機(jī)。缺省值是60 秒。2.2 內(nèi)核的通常值是180秒,你可以按這個(gè)設(shè)置,但要記住的是,即使你的機(jī)器是一個(gè)輕載的WEB服務(wù)器,也有因?yàn)榇罅康乃捞捉幼侄鴥?nèi)存溢出的風(fēng)險(xiǎn),F(xiàn)IN- WAIT-2的危險(xiǎn)性比FIN-WAIT-1要小,因?yàn)樗疃嘀荒艹缘?.5K內(nèi)存,但是它們的生存期長(zhǎng)些。
net.ipv4.tcp_fin_timeout = 1  
#當(dāng)keepalive起用的時(shí)候,TCP發(fā)送keepalive消息的頻度。缺省是2小時(shí)。
net.ipv4.tcp_keepalive_time = 30  
#允許系統(tǒng)打開的端口范圍
net.ipv4.ip_local_port_range = 1024 65000 
#表示文件句柄的最大數(shù)量
fs.file-max = 102400

#云主機(jī)上的優(yōu)化

# Kernel sysctl configuration file for Red Hat Linux
#
# For binary values, 0 is disabled, 1 is enabled.  See sysctl(8) and
# sysctl.conf(5) for more details.

# Controls IP packet forwarding
net.ipv4.ip_forward = 0

# Controls source route verification
net.ipv4.conf.default.rp_filter = 1

# Do not accept source routing
net.ipv4.conf.default.accept_source_route = 0

# Controls the System Request debugging functionality of the kernel

# Controls whether core dumps will append the PID to the core filename.
# Useful for debugging multi-threaded applications.
kernel.core_uses_pid = 1

# Controls the use of TCP syncookies
net.ipv4.tcp_syncookies = 1

# Disable netfilter on bridges.
net.bridge.bridge-nf-call-ip6tables = 0
net.bridge.bridge-nf-call-iptables = 0
net.bridge.bridge-nf-call-arptables = 0

# Controls the default maxmimum size of a mesage queue
kernel.msgmnb = 65536

# Controls the maximum size of a message, in bytes
kernel.msgmax = 65536

# Controls the maximum shared segment size, in bytes
kernel.shmmax = 68719476736

# Controls the maximum number of shared memory segments, in pages
kernel.shmall = 4294967296
net.ipv4.conf.all.send_redirects = 0
net.ipv4.conf.default.send_redirects = 0
net.ipv4.conf.all.secure_redirects = 0
net.ipv4.conf.default.secure_redirects = 0
net.ipv4.conf.all.accept_redirects = 0
net.ipv4.conf.default.accept_redirects = 0
net.ipv4.conf.all.send_redirects = 0
net.ipv4.conf.default.send_redirects = 0
net.ipv4.conf.all.secure_redirects = 0
net.ipv4.conf.default.secure_redirects = 0
net.ipv4.conf.all.accept_redirects = 0
net.ipv4.conf.default.accept_redirects = 0
net.netfilter.nf_conntrack_max = 1000000
kernel.unknown_nmi_panic = 0
kernel.sysrq = 0
fs.file-max = 1000000
vm.swappiness = 10
fs.inotify.max_user_watches = 10000000
net.core.wmem_max = 327679
net.core.rmem_max = 327679
net.ipv4.conf.all.send_redirects = 0
net.ipv4.conf.default.send_redirects = 0
net.ipv4.conf.all.secure_redirects = 0
net.ipv4.conf.default.secure_redirects = 0
net.ipv4.conf.all.accept_redirects = 0
net.ipv4.conf.default.accept_redirects = 0

/sbin/sysctl -p

#自動(dòng)選擇最快的yum源
yum -y install yum-fastestmirror

#移除系統(tǒng)自帶的rpm包的http mysql php
#yum remove httpd* php*
yum remove httpd mysql mysql-server php php-cli php-common php-devel php-gd  -y

#升級(jí)基礎(chǔ)庫
yum install -y wget gcc gcc-c++ openssl* curl curl-devel libxml2 libxml2-devel glibc glibc-devel glib2 glib2-devel gd gd2 gd-devel gd2-devel libaio autoconf libjpeg libjpeg-devel libpng libpng-devel freetype freetype-devel 

#yum安裝基礎(chǔ)必備環(huán)境包,可以先將yum源更換為阿里云的源
阿里:http://mirrors.aliyun.com/ 
搜狐:http://mirrors.sohu.com/ 
網(wǎng)易:http://mirrors.163.com/

#備份原先的yum源信息
mv /etc/yum.repos.d/CentOS-Base.repo /etc/yum.repos.d/CentOS-Base.repo.backup

#從阿里云鏡像站下載centos6的repo
wget -O /etc/yum.repos.d/CentOS-Base.repo http://mirrors.aliyun.com/repo/Centos-6.repo

#最后yum重新生成緩存
yum makecache

#yum安裝軟件包(可選)
yum -y install tar zip unzip openssl* gd gd-devel gcc gcc-c++ autoconf libjpeg libjpeg-devel libpng libpng-devel freetype freetype-devel libxml2 libxml2-devel zlib zlib-devel glibc glibc-devel glib2 glib2-devel bzip2 bzip2-devel ncurses ncurses-devel curl curl-devel e2fsprogs e2fsprogs-devel krb5 krb5-devel libidn libidn-devel openssl openssl-devel openldap openldap-devel openldap-clients openldap-servers make libmcrypt libmcrypt-devel fontconfig fontconfig-devel libXpm* libtool* libxml2 libxml2-devel t1lib t1lib-devel



#定義目錄結(jié)構(gòu),下載安裝包
mkdir -p /app/{local,data}
cd /app/local

#PCRE - Perl Compatible Regular Expressions
wget "ftp://ftp.csx.cam.ac.uk/pub/software/programming/pcre/pcre-8.37.tar.gz"
#Tengine
wget "http://tengine.taobao.org/download/tengine-2.1.0.tar.gz"
#MySQL
wget "https://downloads.mariadb.com/archives/mysql-5.6/mysql-5.6.25-linux-glibc2.5-x86_64.tar.gz"
#PHP
wget "http://cn2.php.net/distributions/php-5.6.11.tar.gz"
#Mhash
wget "http://downloads.sourceforge.net/mhash/mhash-0.9.9.9.tar.gz"
#libmcrypt
wget "http://downloads.sourceforge.net/mcrypt/libmcrypt-2.5.8.tar.gz"
#Mcrypt
wget "http://downloads.sourceforge.net/mcrypt/mcrypt-2.6.8.tar.gz"

配置Tengine 安裝PCRE
bashtar zxvf pcre-8.37.tar.gz
cd pcre-8.37
./configure
make && make install
cd ../

安裝Tengine
bash#添加www用戶和組
groupadd www
useradd -g www www
#安裝Tengine
tar zxvf tengine-2.1.0.tar.gz
cd tengine-2.1.0

./configure --user=www --group=www 
--prefix=/app/local/nginx 
--with-http_stub_status_module 
--with-http_ssl_module 
--with-pcre=/app/local/pcre-8.37

make && make install
cd ../

配置Nginx
  

Nginx配置文件的優(yōu)化很重要,理解每一步的意義

bash#修改nginx.conf
vi /app/local/nginx/conf/nginx.conf

#用戶和用戶組
user  www www;
#工作進(jìn)程,一般可以按CPU核數(shù)設(shè)定
worker_processes  auto;
worker_cpu_affinity auto;
#全局錯(cuò)誤日志級(jí)別
# [ debug | info | notice | warn | error | crit ]
error_log  logs/error.log  error;
#PID文件位置
pid  logs/nginx.pid;
#更改worker進(jìn)程的最大打開文件數(shù)限制,避免"too many open files"
worker_rlimit_nofile 65535;

#events事件指令是設(shè)定Nginx的工作模式及連接數(shù)上限
events{
     #epoll是Linux首選的高效工作模式
     use epoll;
     #告訴nginx收到一個(gè)新連接通知后接受盡可能多的連接
     multi_accept on;
     #用于定義Nginx每個(gè)進(jìn)程的最大連接數(shù)
     worker_connections      65536;
}

#HTTP模塊控制著nginx http處理的所有核心特性
http {
    include       mime.types;
    #設(shè)置文件使用的默認(rèn)的MIME-type
    default_type  application/octet-stream;


    #對(duì)日志格式的設(shè)定,main為日志格式別名
    log_format  main  "$remote_addr - $remote_user [$time_local] "$request" "
                      "$status $body_bytes_sent "$http_referer" "
                      ""$http_user_agent" "$http_x_forwarded_for"";
    #設(shè)置nginx是否將存儲(chǔ)訪問日志。關(guān)閉這個(gè)選項(xiàng)可以讓讀取磁盤IO操作更快
    access_log off;
    # access_log logs/access.log main buffer=16k;

    #開啟gzip壓縮,實(shí)時(shí)壓縮輸出數(shù)據(jù)流
    gzip on;
    #設(shè)置IE6或者更低版本禁用gzip功能
    gzip_disable "MSIE [1-6].";
    #前端的緩存服務(wù)器緩存經(jīng)過gzip壓縮的頁面
    gzip_vary on;
    #允許壓縮基于請(qǐng)求和響應(yīng)的響應(yīng)流
    gzip_proxied any;
    #設(shè)置數(shù)據(jù)的壓縮等級(jí)
    gzip_comp_level 4;
    #設(shè)置對(duì)數(shù)據(jù)啟用壓縮的最少字節(jié)數(shù)
    gzip_min_length 1k;
    #表示申請(qǐng)16個(gè)單位為64K的內(nèi)存作為壓縮結(jié)果流緩存
    gzip_buffers 16 64k;
    #用于設(shè)置識(shí)別HTTP協(xié)議版本
    gzip_http_version 1.1;
    #用來指定壓縮的類型
    gzip_types text/plain text/css application/json application/x-javascript text/xml application/xml application/xml+rss text/javascript;


    #打開緩存的同時(shí)也指定了緩存最大數(shù)目,以及緩存的時(shí)間
    open_file_cache max=200000 inactive=20s;
    #在open_file_cache中指定檢測(cè)正確信息的間隔時(shí)間
    open_file_cache_valid 30s;
    #定義了open_file_cache中指令參數(shù)不活動(dòng)時(shí)間期間里最小的文件數(shù)
    open_file_cache_min_uses 2;
    #指定了當(dāng)搜索一個(gè)文件時(shí)是否緩存錯(cuò)誤信息,也包括再次給配置中添加文件
    open_file_cache_errors on; 

    #設(shè)置允許客戶端請(qǐng)求的最大的單個(gè)文件字節(jié)數(shù)
    client_max_body_size 30M;
    #設(shè)置客戶端請(qǐng)求主體讀取超時(shí)時(shí)間
    client_body_timeout 10;
    #設(shè)置客戶端請(qǐng)求頭讀取超時(shí)時(shí)間
    client_header_timeout 10;
    #指定來自客戶端請(qǐng)求頭的headerbuffer大小
    client_header_buffer_size 32k;
    #設(shè)置客戶端連接保持活動(dòng)的超時(shí)時(shí)間
    keepalive_timeout 60;
    #關(guān)閉不響應(yīng)的客戶端連接
    reset_timedout_connection on;
    #設(shè)置響應(yīng)客戶端的超時(shí)時(shí)間
    send_timeout 10;
    #開啟高效文件傳輸模式
    sendfile on;
    #告訴nginx在一個(gè)數(shù)據(jù)包里發(fā)送所有頭文件,而不一個(gè)接一個(gè)的發(fā)送
    tcp_nopush on;
    #告訴nginx不要緩存數(shù)據(jù),而是一段一段的發(fā)送
    tcp_nodelay on;
    #設(shè)置用于保存各種key(比如當(dāng)前連接數(shù))的共享內(nèi)存的參數(shù)
    limit_conn_zone $binary_remote_addr zone=addr:5m; 
    #給定的key設(shè)置最大連接數(shù),允許每一個(gè)IP地址最多同時(shí)打開有100個(gè)連接
    limit_conn addr 100; 

    #FastCGI相關(guān)參數(shù)是為了改善網(wǎng)站的性能:減少資源占用,提高訪問速度
    fastcgi_buffers 256 16k;
    fastcgi_buffer_size 128k;
    fastcgi_connect_timeout 3s;
    fastcgi_send_timeout 120s;
    fastcgi_read_timeout 120s;
    server_names_hash_bucket_size 128;
    #不在error_log中記錄不存在的錯(cuò)誤
    log_not_found off;
    #關(guān)閉在錯(cuò)誤頁面中的nginx版本數(shù)字,提高安全性
    #server_tag Apache;
    server_tokens off;
    #tengine
    server_tag off;
    server_info off;

    #添加虛擬主機(jī)的配置文件
    include vhosts/*.conf;

    #負(fù)載均衡配置(暫時(shí)略過)
    #upstream test.com

    #設(shè)定虛擬主機(jī)配置
    server {
        #偵聽80端口
        listen       80;
        #定義使用localhost訪問
        server_name  localhost;
        #定義首頁索引文件的名稱
        index index.html index.htm index.php;
        #定義服務(wù)器的默認(rèn)網(wǎng)站根目錄位置
        root    /app/data/localhost/;

        #定義錯(cuò)誤提示頁面
        error_page  404              /404.html;
        error_page  500 502 503 504  /50x.html;
        location = /50x.html {
            root   html;
        }

        #PHP 腳本請(qǐng)求全部轉(zhuǎn)發(fā)到 FastCGI處理. 使用FastCGI默認(rèn)配置.     
        location ~ .*.(php|php5)?$ {
            fastcgi_pass   127.0.0.1:9000;
            fastcgi_index  index.php;
            include        fastcgi.conf;
        }

        #靜態(tài)文件
        location ~ .*.(gif|jpg|jpeg|png|bmp|swf|ico)$
        {
            #過期30天,頻繁更新可設(shè)置小一點(diǎn)
            expires      30d;
        }

        location ~ .*.(js|css)?$
        {
            #過期1小時(shí),不更新可設(shè)置大一些
            expires      1h;
        }
        #禁止訪問
        location ~ /. {
            deny all;
        }
    }
}

  

簡(jiǎn)化配置文件
vi /app/local/nginx/conf/nginx.conf

bash
user www www; worker_processes auto; worker_cpu_affinity auto; error_log logs/error.log crit; pid logs/nginx.pid; worker_rlimit_nofile 51200; events { use epoll; multi_accept on; worker_connections 51200; } http { include mime.types; default_type application/octet-stream; log_format main "$remote_addr - $remote_user [$time_local] "$request" " "$status $body_bytes_sent "$http_referer" " ""$http_user_agent" "$http_x_forwarded_for""; access_log off; #access_log logs/access.log main buffer=16k; server_names_hash_bucket_size 128; client_header_buffer_size 32k; large_client_header_buffers 4 32k; client_max_body_size 50M; sendfile on; tcp_nopush on; tcp_nodelay on; keepalive_timeout 60; server_tokens off; server_tag off; server_info off; fastcgi_connect_timeout 300; fastcgi_send_timeout 300; fastcgi_read_timeout 300; fastcgi_buffer_size 64k; fastcgi_buffers 4 64k; fastcgi_busy_buffers_size 128k; fastcgi_temp_file_write_size 256k; #gzip on; #gzip_min_length 1k; #gzip_buffers 4 16k; #gzip_http_version 1.1; #gzip_comp_level 5; #gzip_types text/plain application/x-javascript text/css application/xml; #gzip_vary on; include vhosts/*.conf; }
  

分離server寫入vhosts
mkdir -p /app/local/nginx/conf/vhosts/
vi /app/local/nginx/conf/vhosts/localhost.conf

bashserver {
    listen       80;
    server_name  localhost;
    index index.php index.html index.htm;
    access_log  logs/localhost.log  main;

    root    /app/data/localhost/;

    location / {
        index  index.php index.html index.htm;
    }

    #error_page  404              /404.html;
    #error_page  500 502 503 504  /50x.html;

    location = /50x.html {
        root   html;
    }

    location ~ .*.(php|php5)?$ {
        fastcgi_pass   127.0.0.1:9000;
        fastcgi_index  index.php;
      #fastcgi_param  SCRIPT_FILENAME $document_root$fastcgi_script_name;
        include        fastcgi.conf;
    }

    location ~ .*.(gif|jpg|jpeg|png|bmp|swf|ico)$
    {
        expires      30d;
    }

    location ~ .*.(js|css)?$
    {
        expires      1h;
    }

    location ~ /. {
        deny all;
    }
}

bash#檢查語法
/app/local/nginx/sbin/nginx -t
# ./nginx -t
the configuration file /app/local/nginx/conf/nginx.conf syntax is ok
configuration file /app/local/nginx/conf/nginx.conf test is successful

#測(cè)試用例
mkdir -p /app/data/localhost
chmod +w /app/data/localhost
echo "" > /app/data/localhost/phpinfo.php
chown -R www:www /app/data/localhost

#設(shè)置nginx系統(tǒng)變量
echo "export PATH=$PATH:/app/local/nginx/sbin">>/etc/profile && source /etc/profile

#測(cè)試訪問
curl -I http://localhost

HTTP/1.1 200 OK
Server: Tengine/2.1.0
Date: Mon, 27 Jul 2015 06:42:25 GMT
Content-Type: text/html; charset=UTF-8
Connection: keep-alive
X-Powered-By: PHP/5.6.11


添加Tengine到服務(wù)
  

配置服務(wù)后便于統(tǒng)一管理
vi /etc/rc.d/init.d/nginx

bash#!/bin/sh

# Source function library.
. /etc/rc.d/init.d/functions

# Source networking configuration.
. /etc/sysconfig/network

# Check that networking is up.
[ "$NETWORKING" = "no" ] && exit 0

nginx="/app/local/nginx/sbin/nginx"
prog=$(basename $nginx)

NGINX_CONF_FILE="/app/local/nginx/conf/nginx.conf"

[ -f /etc/sysconfig/nginx ] && . /etc/sysconfig/nginx

lockfile=/var/lock/subsys/nginx

make_dirs() {
   # make required directories
   user=`$nginx -V 2>&1 | grep "configure arguments:" | sed "s/[^*]*--user=([^ ]*).*/1/g" -`
   if [ -z "`grep $user /etc/passwd`" ]; then
       useradd -M -s /bin/nologin $user
   fi
   options=`$nginx -V 2>&1 | grep "configure arguments:"`
   for opt in $options; do
       if [ `echo $opt | grep ".*-temp-path"` ]; then
           value=`echo $opt | cut -d "=" -f 2`
           if [ ! -d "$value" ]; then
               # echo "creating" $value
               mkdir -p $value && chown -R $user $value
           fi
       fi
   done
}

start() {
    [ -x $nginx ] || exit 5
    [ -f $NGINX_CONF_FILE ] || exit 6
    make_dirs
    echo -n $"Starting $prog: "
    daemon $nginx -c $NGINX_CONF_FILE
    retval=$?
    echo
    [ $retval -eq 0 ] && touch $lockfile
    return $retval
}

stop() {
    echo -n $"Stopping $prog: "
    killproc $prog -QUIT
    retval=$?
    echo
    [ $retval -eq 0 ] && rm -f $lockfile
    return $retval
}

restart() {
    configtest || return $?
    stop
    sleep 1
    start
}

reload() {
    configtest || return $?
    echo -n $"Reloading $prog: "
    killproc $nginx -HUP
    RETVAL=$?
    echo
}

force_reload() {
    restart
}

configtest() {
  $nginx -t -c $NGINX_CONF_FILE
}

rh_status() {
    status $prog
}

rh_status_q() {
    rh_status >/dev/null 2>&1
}

case "$1" in
    start)
        rh_status_q && exit 0
        $1
        ;;
    stop)
        rh_status_q || exit 0
        $1
        ;;
    restart|configtest)
        $1
        ;;
    reload)
        rh_status_q || exit 7
        $1
        ;;
    force-reload)
        force_reload
        ;;
    status)
        rh_status
        ;;
    condrestart|try-restart)
        rh_status_q || exit 0
            ;;
    *)
        echo $"Usage: $0 {start|stop|status|restart|condrestart|try-restart|reload|force-reload|configtest}"
        exit 2
esac

bash#修改執(zhí)行權(quán)限
chmod +x /etc/init.d/nginx
ulimit -SHn 65535
service nginx start

安裝MySQL
  

注意目錄和字符集等配置文件

bash#解壓mysql
mkdir -p /app/local/mysql
tar zxvf mysql-5.6.25-linux-glibc2.5-x86_64.tar.gz
mv mysql-5.6.25-linux-glibc2.5-x86_64/* /app/local/mysql
#增加mysql用戶組
groupadd mysql
useradd -g mysql mysql
mkdir -p /app/data/mysql/data/
mkdir -p /app/data/mysql/binlog/
mkdir -p /app/data/mysql/relaylog/
chown -R mysql:mysql /app/data/mysql/
 #安裝mysql
/app/local/mysql/scripts/mysql_install_db --basedir=/app/local/mysql --datadir=/app/data/mysql/data --user=mysql
#修改mysqld_safe配置路徑
sed -i "s#/usr/local/mysql#/app/local/mysql#g" /app/local/mysql/bin/mysqld_safe

bash
#修改my.cnf配置文件 vi /app/local/mysql/my.cnf [client] character-set-server = utf8 port = 3306 socket = /tmp/mysql.sock [mysql] #prompt="(u:HOSTNAME:)[d]> " prompt="u@h R:m:s [d]> " no-auto-rehash [mysqld] server-id = 1 port = 3306 user = mysql basedir = /app/local/mysql datadir = /app/data/mysql/data socket = /tmp/mysql.sock log-error = /app/data/mysql/mysql_error.log pid-file = /app/data/mysql/mysql.pid sql_mode=NO_ENGINE_SUBSTITUTION,STRICT_TRANS_TABLES default-storage-engine = InnoDB max_connections = 512 max_connect_errors = 100000 table_open_cache = 512 external-locking = FALSE max_allowed_packet = 32M slow_query_log = 1 slow_query_log_file = /app/data/mysql/slow.log open_files_limit = 10240 back_log = 600 join_buffer_size = 2M read_rnd_buffer_size = 16M sort_buffer_size = 2M thread_cache_size = 300 query_cache_size = 128M query_cache_limit = 2M query_cache_min_res_unit = 2k thread_stack = 192K transaction_isolation = READ-COMMITTED tmp_table_size = 246M max_heap_table_size = 246M long_query_time = 3 log-slave-updates log-bin = /app/data/mysql/binlog/binlog sync_binlog = 1 binlog_cache_size = 4M binlog_format = MIXED max_binlog_cache_size = 8M max_binlog_size = 1G relay-log-index = /app/data/mysql/relaylog/relaylog relay-log-info-file = /app/data/mysql/relaylog/relaylog relay-log = /app/data/mysql/relaylog/relaylog expire_logs_days = 7 key_buffer_size = 128M read_buffer_size = 1M read_rnd_buffer_size = 16M bulk_insert_buffer_size = 64M myisam_sort_buffer_size = 128M myisam_max_sort_file_size = 10G myisam_repair_threads = 1 myisam_recover innodb_additional_mem_pool_size = 16M innodb_buffer_pool_size = 256M innodb_data_file_path = ibdata1:1024M:autoextend innodb_flush_log_at_trx_commit = 1 innodb_log_buffer_size = 16M innodb_log_file_size = 256M innodb_log_files_in_group = 2 innodb_max_dirty_pages_pct = 50 innodb_file_per_table = 1 innodb_locks_unsafe_for_binlog = 0 interactive_timeout = 120 wait_timeout = 120 skip-name-resolve slave-skip-errors = 1032,1062,126,1114,1146,1048,1396 [mysqldump] quick max_allowed_packet = 32M
bash
#添加mysql到服務(wù) vi /etc/rc.d/init.d/mysqld #!/bin/sh basedir=/app/local/mysql datadir=/app/data/mysql/data service_startup_timeout=900 lockdir="/var/lock/subsys" lock_file_path="$lockdir/mysql" mysqld_pid_file_path=/app/data/mysql/mysql.pid if test -z "$basedir" then basedir=/usr/local/mysql bindir=/usr/local/mysql/bin if test -z "$datadir" then datadir=/usr/local/mysql/data fi sbindir=/usr/local/mysql/bin libexecdir=/usr/local/mysql/bin else bindir="$basedir/bin" if test -z "$datadir" then datadir="$basedir/data" fi sbindir="$basedir/sbin" libexecdir="$basedir/libexec" fi datadir_set= lsb_functions="/lib/lsb/init-functions" if test -f $lsb_functions ; then . $lsb_functions else log_success_msg() { echo " SUCCESS! $@" } log_failure_msg() { echo " ERROR! $@" } fi PATH="/sbin:/usr/sbin:/bin:/usr/bin:$basedir/bin" export PATH mode=$1 # start or stop [ $# -ge 1 ] && shift other_args="$*" # uncommon, but needed when called from an RPM upgrade action # Expected: "--skip-networking --skip-grant-tables" # They are not checked here, intentionally, as it is the resposibility # of the "spec" file author to give correct arguments only. case `echo "testingc"`,`echo -n testing` in *c*,-n*) echo_n= echo_c= ;; *c*,*) echo_n=-n echo_c= ;; *) echo_n= echo_c="c" ;; esac parse_server_arguments() { for arg do case "$arg" in --basedir=*) basedir=`echo "$arg" | sed -e "s/^[^=]*=//"` bindir="$basedir/bin" if test -z "$datadir_set"; then datadir="$basedir/data" fi sbindir="$basedir/sbin" libexecdir="$basedir/libexec" ;; --datadir=*) datadir=`echo "$arg" | sed -e "s/^[^=]*=//"` datadir_set=1 ;; --pid-file=*) mysqld_pid_file_path=`echo "$arg" | sed -e "s/^[^=]*=//"` ;; --service-startup-timeout=*) service_startup_timeout=`echo "$arg" | sed -e "s/^[^=]*=//"` ;; esac done } wait_for_pid () { verb="$1" # created | removed pid="$2" # process ID of the program operating on the pid-file pid_file_path="$3" # path to the PID file. i=0 avoid_race_condition="by checking again" while test $i -ne $service_startup_timeout ; do case "$verb" in "created") # wait for a PID-file to pop into existence. test -s "$pid_file_path" && i="" && break ;; "removed") # wait for this PID-file to disappear test ! -s "$pid_file_path" && i="" && break ;; *) echo "wait_for_pid () usage: wait_for_pid created|removed pid pid_file_path" exit 1 ;; esac # if server isn"t running, then pid-file will never be updated if test -n "$pid"; then if kill -0 "$pid" 2>/dev/null; then : # the server still runs else # The server may have exited between the last pid-file check and now. if test -n "$avoid_race_condition"; then avoid_race_condition="" continue # Check again. fi # there"s nothing that will affect the file. log_failure_msg "The server quit without updating PID file ($pid_file_path)." return 1 # not waiting any more. fi fi echo $echo_n ".$echo_c" i=`expr $i + 1` sleep 1 done if test -z "$i" ; then log_success_msg return 0 else log_failure_msg return 1 fi } # Get arguments from the my.cnf file, # the only group, which is read from now on is [mysqld] if test -x ./bin/my_print_defaults then print_defaults="./bin/my_print_defaults" elif test -x $bindir/my_print_defaults then print_defaults="$bindir/my_print_defaults" elif test -x $bindir/mysql_print_defaults then print_defaults="$bindir/mysql_print_defaults" else # Try to find basedir in /etc/my.cnf conf=/etc/my.cnf print_defaults= if test -r $conf then subpat="^[^=]*basedir[^=]*=(.*)$" dirs=`sed -e "/$subpat/!d" -e "s//1/" $conf` for d in $dirs do d=`echo $d | sed -e "s/[ ]//g"` if test -x "$d/bin/my_print_defaults" then print_defaults="$d/bin/my_print_defaults" break fi if test -x "$d/bin/mysql_print_defaults" then print_defaults="$d/bin/mysql_print_defaults" break fi done fi # Hope it"s in the PATH ... but I doubt it test -z "$print_defaults" && print_defaults="my_print_defaults" fi # # Read defaults file from "basedir". If there is no defaults file there # check if it"s in the old (depricated) place (datadir) and read it from there # extra_args="" if test -r "$basedir/my.cnf" then extra_args="-e $basedir/my.cnf" else if test -r "$datadir/my.cnf" then extra_args="-e $datadir/my.cnf" fi fi parse_server_arguments `$print_defaults $extra_args mysqld server mysql_server mysql.server` # # Set pid file if not given # if test -z "$mysqld_pid_file_path" then mysqld_pid_file_path=$datadir/`hostname`.pid else case "$mysqld_pid_file_path" in /* ) ;; * ) mysqld_pid_file_path="$datadir/$mysqld_pid_file_path" ;; esac fi case "$mode" in "start") # Start daemon # Safeguard (relative paths, core dumps..) cd $basedir echo $echo_n "Starting MySQL" if test -x $bindir/mysqld_safe then # Give extra arguments to mysqld with the my.cnf file. This script # may be overwritten at next upgrade. $bindir/mysqld_safe --datadir="$datadir" --pid-file="$mysqld_pid_file_path" $other_args >/dev/null 2>&1 & wait_for_pid created "$!" "$mysqld_pid_file_path"; return_value=$? # Make lock for RedHat / SuSE if test -w "$lockdir" then touch "$lock_file_path" fi exit $return_value else log_failure_msg "Couldn"t find MySQL server ($bindir/mysqld_safe)" fi ;; "stop") # Stop daemon. We use a signal here to avoid having to know the # root password. if test -s "$mysqld_pid_file_path" then mysqld_pid=`cat "$mysqld_pid_file_path"` if (kill -0 $mysqld_pid 2>/dev/null) then echo $echo_n "Shutting down MySQL" kill $mysqld_pid # mysqld should remove the pid file when it exits, so wait for it. wait_for_pid removed "$mysqld_pid" "$mysqld_pid_file_path"; return_value=$? else log_failure_msg "MySQL server process #$mysqld_pid is not running!" rm "$mysqld_pid_file_path" fi # Delete lock for RedHat / SuSE if test -f "$lock_file_path" then rm -f "$lock_file_path" fi exit $return_value else log_failure_msg "MySQL server PID file could not be found!" fi ;; "restart") # Stop the service and regardless of whether it was # running or not, start it again. if $0 stop $other_args; then $0 start $other_args else log_failure_msg "Failed to stop running server, so refusing to try to start." exit 1 fi ;; "reload"|"force-reload") if test -s "$mysqld_pid_file_path" ; then read mysqld_pid < "$mysqld_pid_file_path" kill -HUP $mysqld_pid && log_success_msg "Reloading service MySQL" touch "$mysqld_pid_file_path" else log_failure_msg "MySQL PID file could not be found!" exit 1 fi ;; "status") # First, check to see if pid file exists if test -s "$mysqld_pid_file_path" ; then read mysqld_pid < "$mysqld_pid_file_path" if kill -0 $mysqld_pid 2>/dev/null ; then log_success_msg "MySQL running ($mysqld_pid)" exit 0 else log_failure_msg "MySQL is not running, but PID file exists" exit 1 fi else # Try to find appropriate mysqld process mysqld_pid=`pidof $libexecdir/mysqld` # test if multiple pids exist pid_count=`echo $mysqld_pid | wc -w` if test $pid_count -gt 1 ; then log_failure_msg "Multiple MySQL running but PID file could not be found ($mysqld_pid)" exit 5 elif test -z $mysqld_pid ; then if test -f "$lock_file_path" ; then log_failure_msg "MySQL is not running, but lock file ($lock_file_path) exists" exit 2 fi log_failure_msg "MySQL is not running" exit 3 else log_failure_msg "MySQL is running but PID file could not be found" exit 4 fi fi ;; *) # usage basename=`basename "$0"` echo "Usage: $basename {start|stop|restart|reload|force-reload|status} [ MySQL server options ]" exit 1 ;; esac exit 0
bash#修改權(quán)限
chmod +x /etc/init.d/mysqld
service mysqld start

#增加MySQL系統(tǒng)環(huán)境變量
echo "export PATH=$PATH:/app/local/mysql/bin">>/etc/profile && source /etc/profile

#查看錯(cuò)誤日志
tail -f /var/log/mysqld.log 

#用root賬戶登錄并作簡(jiǎn)單的安全設(shè)置
/app/local/mysql/bin/mysql -uroot -p

sql#修改root密碼
UPDATE mysql.user SET Password=password("root") WHERE User="root";

#刪除無名用戶
DELETE FROM mysql.user WHERE User="";

#刪除root遠(yuǎn)程訪問
DELETE FROM mysql.user WHERE User="root" AND Host NOT IN ("localhost", "127.0.0.1", "::1");

#刪除“test”數(shù)據(jù)庫
DROP database test;

#允許遠(yuǎn)程訪問
/app/local/mysql/bin/mysql -uroot -proot

use mysql;
update user set host="%" where user="root" AND host="localhost";
FLUSH PRIVILEGES;
select host, user from user;

#立即生效并退出MYSQL命令窗體
FLUSH PRIVILEGES;QUIT;

安裝Apache
bashcd /app/local
tar zxvf httpd-2.2.29.tar.gz
cd httpd-2.2.29

./configure --prefix=/app/local/apache 
--enable-so 
--enable-rewrite 
--enable-modes-shared=most

make && make install 

vi /app/local/apache/conf/httpd.conf

#修改主機(jī)名
ServerName localhost:80
#查找AddType application/x-gzip .gz .tgz,在該行下面添加
AddType application/x-httpd-php .php
#查找DirectoryIndex index.html 把該行修改成
DirectoryIndex index.html index.htm index.php

/app/local/apache/bin/apachectl -t
cp /app/local/apache/bin/apachectl /etc/init.d/httpd


安裝PHP PHP基礎(chǔ)環(huán)境
bash#yum安裝或者使用下面源包編譯安裝
yum install libmcrypt libmcrypt-devel mcrypt mhash

#下載地址
http://sourceforge.net/projects/mcrypt/files/Libmcrypt/
http://sourceforge.net/projects/mcrypt/files/MCrypt/
http://sourceforge.net/projects/mhash/files/mhash/

#安裝Libmcrypt
tar -zxvf libmcrypt-2.5.8.tar.gz
cd libmcrypt-2.5.8
./configure
make && make install
cd ../

3.安裝mhash

tar -zxvf mhash-0.9.9.9.tar.gz
cd mhash-0.9.9.9
./configure
make && make install
cd ../

4.安裝mcrypt

tar -zxvf mcrypt-2.6.8.tar.gz
cd mcrypt-2.6.8
LD_LIBRARY_PATH=/usr/local/lib ./configure
make && make install
cd ../

### 安裝PHP

>extension根據(jù)需要定制,新增的OPcache建議暫時(shí)不要開啟

``` bash
tar zxvf php-5.5.27.tar.gz
cd php-5.5.27

./configure --prefix=/app/local/php 
--with-config-file-path=/app/local/php/etc 
--enable-fpm 
--enable-mbstring 
--with-mhash 
--with-mcrypt 
--with-curl 
--with-openssl 
--with-mysql=mysqlnd 
--with-mysqli=mysqlnd 
--with-pdo-mysql=mysqlnd 
--with-apxs2=/app/local/apache/bin/apxs 
#--enable-opcache

make && make install

#配置php.ini
cp php.ini-development /app/local/php/etc/php.ini

#設(shè)置時(shí)區(qū)
sed -i "s#;date.timezone =#date.timezone = Asia/Shanghai#g" /app/local/php/etc/php.ini
#防止nginx文件類型錯(cuò)誤解析漏洞
sed -i "s#;cgi.fix_pathinfo=1#cgi.fix_pathinfo=0#g" /app/local/php/etc/php.ini
#禁止顯示php版本的信息
sed -i "s#expose_php = On#expose_php = Off#g" /app/local/php/etc/php.ini
#禁用危險(xiǎn)函數(shù)(可選)
#sed -i "s#disable_functions =#disable_functions = exec,passthru,shell_exec,system,proc_open,popen,curl_exec,curl_multi_exec,parse_ini_file,show_source#g" /app/local/php/etc/php.ini

#enable-opcache后設(shè)置(可選)
[OPcache]
zend_extension = opcache.so
opcache.enable=1
opcache.memory_consumption = 64
opcache.interned_strings_buffer = 8
opcache.max_accelerated_files = 4000
opcache.revalidate_freq = 60
opcache.fast_shutdown = 1
opcache.enable_cli = 1

配置php-fpm
bash#編輯php-fpm
cp /app/local/php/etc/php-fpm.conf.default /app/local/php/etc/php-fpm.conf
vi /app/local/php/etc/php-fpm.conf

[global]
;錯(cuò)誤日志
error_log = log/php-fpm.log
;錯(cuò)誤日志級(jí)別
log_level = notice
[www]
;php-fpm監(jiān)聽端口
listen = 127.0.0.1:9000
;啟動(dòng)進(jìn)程的帳戶和組
user = www
group = www
;如果選擇static,則由pm.max_children指定固定的子進(jìn)程數(shù)。如果選擇dynamic,則由后面3個(gè)參數(shù)動(dòng)態(tài)決定
pm = dynamic
;子進(jìn)程最大數(shù)
pm.max_children = 384
;啟動(dòng)時(shí)的進(jìn)程數(shù)
pm.start_servers = 20
;保證空閑進(jìn)程數(shù)最小值,如果空閑進(jìn)程小于此值,則創(chuàng)建新的子進(jìn)程
pm.min_spare_servers = 5
;保證空閑進(jìn)程數(shù)最大值,如果空閑進(jìn)程大于此值,此進(jìn)行清理
pm.max_spare_servers = 35

;設(shè)置每個(gè)子進(jìn)程重生之前服務(wù)的請(qǐng)求數(shù)。對(duì)于可能存在內(nèi)存泄漏的第三方模塊來說是非常有用的。如果設(shè)置為 "0" 則一直接受請(qǐng)求。等同于 PHP_FCGI_MAX_REQUESTS 環(huán)境變量。默認(rèn)值: 0。
pm.max_requests = 1000
;每個(gè)子進(jìn)程閑置多長(zhǎng)時(shí)間就自殺
pm.process_idle_timeout = 10s
;設(shè)置單個(gè)請(qǐng)求的超時(shí)中止時(shí)間。該選項(xiàng)可能會(huì)對(duì)php.ini設(shè)置中的"max_execution_time"因?yàn)槟承┨厥庠驔]有中止運(yùn)行的腳本有用。設(shè)置為 "0" 表示 "Off".當(dāng)經(jīng)常出現(xiàn)502錯(cuò)誤時(shí)可以嘗試更改此選項(xiàng)。
request_terminate_timeout = 120
;當(dāng)一個(gè)請(qǐng)求該設(shè)置的超時(shí)時(shí)間后,就會(huì)將對(duì)應(yīng)的PHP調(diào)用堆棧信息完整寫入到慢日志中。設(shè)置為 "0" 表示 "Off"
request_slowlog_timeout = 3s
;慢請(qǐng)求的記錄日志,配合request_slowlog_timeout使用
slowlog = /app/local/php/var/log/php-fpm.slow.log
;設(shè)置文件打開描述符的rlimit限制。默認(rèn)值: 系統(tǒng)定義值默認(rèn)可打開句柄是1024,可使用 ulimit -n查看,ulimit -n 2048修改。
rlimit_files = 65535

bash
#設(shè)置php環(huán)境變量 echo "export PATH=$PATH:/app/local/php/bin">>/etc/profile && source /etc/profile touch /app/local/php/var/log/php-fpm.slow.log #添加php-fpm服務(wù) cp /app/local/php-5.5.27/sapi/fpm/init.d.php-fpm /etc/rc.d/init.d/php-fpm chmod +x /etc/rc.d/init.d/php-fpm service php-fpm start #設(shè)置開機(jī)自動(dòng)啟動(dòng)服務(wù) vi /etc/rc.local ulimit -SHn 65535 service php-fpm start service nginx start service mysqld start
配置memcache/mongo/redis
  

其它extension擴(kuò)展都可以動(dòng)態(tài)添加,沒事的

bash#memcache
cd /app/local
tar zxvf memcache-3.0.8.tgz
cd memcache-3.0.8
/app/local/php/bin/phpize
./configure --enable-memcache 
--with-php-config=/app/local/php/bin/php-config 
--with-zlib-dir
make && make install

#mongo
cd /app/local
tar zxvf mongo-1.6.10.tgz
cd mongo-1.6.10
/app/local/php/bin/phpize
./configure --with-php-config=/app/local/php/bin/php-config
make && make install

#redis
cd /app/local
tar zxvf redis-2.2.7.tgz
cd redis-2.2.7
/app/local/php/bin/phpize
./configure --with-php-config=/app/local/php/bin/php-config
make && make install

#php.ini
vi /app/local/php/etc/php.ini  

[memcached]  
extension=memcached.so
[mongodb]  
extension=mongo.so 
[redis]  
extension=redis.so 

#重啟生效
service php-fpm restart
php -i | grep php.ini
php -m

自動(dòng)化部署
  

服務(wù)器的上傳目錄可以自定義,安裝目錄默認(rèn)統(tǒng)一修改為/app/{local,data},執(zhí)行腳本為web.sh

bashfile://E:QQDownloadLTMP     (2 folders, 5 files, 27.66 MB, 30.76 MB in total.)
│  httpd-2.2.29.tar.gz     7.19 MB
│  pcre-8.37.tar.gz     1.95 MB
│  php-5.5.27.tar.gz     16.95 MB
│  tengine-2.1.0.tar.gz     1.58 MB
│  web.sh     4.10 KB
├─init     (1 folders, 12 files, 91.42 KB, 92.23 KB in total.)
│  │  allow.conf     35 bytes
│  │  bashrc     2.99 KB
│  │  deny.conf     35 bytes
│  │  limits.conf     1.86 KB
│  │  my.cnf     1.99 KB
│  │  mysqld     8.39 KB
│  │  nginx     2.22 KB
│  │  nginx.conf     1.34 KB
│  │  php-fpm     2.30 KB
│  │  php-fpm.conf     416 bytes
│  │  php.ini     67.83 KB
│  │  sysctl.conf     2.03 KB
│  └─vhosts     (0 folders, 1 files, 826 bytes, 826 bytes in total.)
│          localhost.conf     826 bytes
└─src     (0 folders, 6 files, 3.01 MB, 3.01 MB in total.)
        libmcrypt-2.5.8.tar.gz     1.27 MB
        mcrypt-2.6.8.tar.gz     460.85 KB
        memcache-3.0.8.tgz     68.87 KB
        mhash-0.9.9.9.tar.gz     909.61 KB
        mongo-1.6.10.tgz     204.19 KB
        redis-2.2.7.tgz     131.19 KB


#web.sh

#!/bin/bash

## alias
ltmp_local=$(cd "$(dirname "$0")"; pwd)
mkdir -p /app/{local,data}
unalias cp
ltmp_init=$ltmp_local/init/
ltmp_src=$ltmp_local/src/

## system

#history
cp ${ltmp_init}bashrc /etc/
#time
rm -rf /etc/localtime
ln -s /usr/share/zoneinfo/Asia/Shanghai /etc/localtime
#maildrop
sed "s/MAILTO=root/MAILTO=""/g" /etc/crontab
service crond restart
#selinux
setenforce 0
sed -i "s/SELINUX=enforcing/SELINUX=disabled/" /etc/selinux/config
#limits
echo ulimit -SHn 65535 >> /etc/profile
source /etc/profile
cp ${ltmp_init}limits.conf /etc/security/
#tcp
cp ${ltmp_init}sysctl.conf  /etc/
#yum
yum -y install yum-fastestmirror
yum remove httpd mysql mysql-server php php-cli php-common php-devel php-gd  -y
yum install -y wget gcc gcc-c++ openssl* curl curl-devel libxml2 libxml2-devel glibc glibc-devel glib2 glib2-devel gd gd2 gd-devel gd2-devel libaio autoconf libjpeg libjpeg-devel libpng libpng-devel freetype freetype-devel
#download

cd /app/local
##PCRE - Perl Compatible Regular Expressions
#wget "ftp://ftp.csx.cam.ac.uk/pub/software/programming/pcre/pcre-8.37.tar.gz"
##Tengine
#wget "http://tengine.taobao.org/download/tengine-2.1.0.tar.gz"
##MySQL
#wget "https://downloads.mariadb.com/archives/mysql-5.6/mysql-5.6.25-linux-glibc2.5-x86_64.tar.gz"
##PHP
#wget "http://cn2.php.net/distributions/php-5.6.11.tar.gz"
##Mhash
#wget "http://downloads.sourceforge.net/mhash/mhash-0.9.9.9.tar.gz"
##libmcrypt
#wget "http://downloads.sourceforge.net/mcrypt/libmcrypt-2.5.8.tar.gz"
##Mcrypt
#wget "http://downloads.sourceforge.net/mcrypt/mcrypt-2.6.8.tar.gz"

## soft
cd $ltmp_local
#pcre
tar zxvf pcre-8.37.tar.gz 1> /dev/null
cd pcre-8.37
./configure
make && make install
cd ../
#tengine
groupadd www
useradd -g www www
#安裝Tengine
cd $ltmp_local
tar zxvf tengine-2.1.0.tar.gz 1> /dev/null
cd tengine-2.1.0
./configure --user=www --group=www 
--prefix=/app/local/nginx 
--with-http_stub_status_module 
--with-http_ssl_module 
--with-pcre=${ltmp_local}/pcre-8.37
make && make install
cd ../
#nginx config
cd $ltmp_local
cp ${ltmp_init}nginx.conf /app/local/nginx/conf/
cp -r ${ltmp_init}vhosts /app/local/nginx/conf/
mkdir -p /app/data/localhost
chmod +w /app/data/localhost
echo "" > /app/data/localhost/phpinfo.php
chown -R www:www /app/data/localhost
echo "export PATH=$PATH:/app/local/nginx/sbin">>/etc/profile && source /etc/profile
cp ${ltmp_init}nginx /etc/rc.d/init.d/
chmod +x /etc/init.d/nginx
ulimit -SHn 65535
service nginx start
#libmcrypt
cd $ltmp_src
tar -zxvf libmcrypt-2.5.8.tar.gz 1> /dev/null
cd libmcrypt-2.5.8
./configure
make && make install
cd ../
#mhash
cd $ltmp_src
tar -zxvf mhash-0.9.9.9.tar.gz 1> /dev/null
cd mhash-0.9.9.9
./configure
make && make install
cd ../
#mcrypt
cd $ltmp_src
tar -zxvf mcrypt-2.6.8.tar.gz 1> /dev/null
cd mcrypt-2.6.8
LD_LIBRARY_PATH=/usr/local/lib ./configure
make && make install
cd ../
#php
cd $ltmp_local
tar zxvf php-5.5.27.tar.gz 1> /dev/null
cd php-5.5.27
./configure --prefix=/app/local/php 
--with-config-file-path=/app/local/php/etc 
--enable-fpm 
--enable-mbstring 
--with-mhash 
--with-mcrypt 
--with-curl 
--with-openssl 
--with-mysql=mysqlnd 
--with-mysqli=mysqlnd 
--with-pdo-mysql=mysqlnd
make && make install
#memcache
cd $ltmp_src
tar zxvf memcache-3.0.8.tgz  1> /dev/null
cd memcache-3.0.8
/app/local/php/bin/phpize
./configure --enable-memcache 
--with-php-config=/app/local/php/bin/php-config 
--with-zlib-dir
make && make install
#mongo
cd $ltmp_src
tar zxvf mongo-1.6.10.tgz  1> /dev/null
cd mongo-1.6.10
/app/local/php/bin/phpize
./configure --with-php-config=/app/local/php/bin/php-config
make && make install
#redis
cd $ltmp_src
#redis
tar zxvf redis-2.2.7.tgz  1> /dev/null
cd redis-2.2.7
/app/local/php/bin/phpize
./configure --with-php-config=/app/local/php/bin/php-config
make && make install
#php-fpm
cp ${ltmp_init}php.ini /app/local/php/etc/
cp ${ltmp_init}php-fpm.conf /app/local/php/etc/
echo "export PATH=$PATH:/app/local/php/bin">>/etc/profile && source /etc/profile
touch /app/local/php/var/log/php-fpm.slow.log
cp ${ltmp_local}/php-5.5.27/sapi/fpm/init.d.php-fpm /etc/rc.d/init.d/php-fpm
chmod +x /etc/rc.d/init.d/php-fpm
service php-fpm start



文章版權(quán)歸作者所有,未經(jīng)允許請(qǐng)勿轉(zhuǎn)載,若此文章存在違規(guī)行為,您可以聯(lián)系管理員刪除。

轉(zhuǎn)載請(qǐng)注明本文地址:http://specialneedsforspecialkids.com/yun/21047.html

相關(guān)文章

  • phpMyAdmin無需填寫IP管理多個(gè)MySQL實(shí)踐

    摘要:前言默認(rèn)安裝,通常只能連一臺(tái)服務(wù)器,其配置信息是保存在的配置文件里的,當(dāng)我們需要在多臺(tái)服務(wù)器之間進(jìn)行切換登陸的時(shí)候,修改起來非常麻煩。遵照下面的配置方法,我們可以方便的使用連接多臺(tái)。 showImg(//i.v2ex.co/68353qlH.png); 前言 默認(rèn)安裝phpMyAdmin,通常只能連一臺(tái)MySQL服務(wù)器,其配置信息是保存在phpMyAdmin的配置文件里的,當(dāng)我們需要在...

    孫淑建 評(píng)論0 收藏0
  • 使用RockMongo管理MongoDB

    摘要:前言和數(shù)據(jù)庫相比的管理工具其實(shí)不算多,除了客戶端以外想要通過類似一樣通過管理的數(shù)據(jù)庫應(yīng)該也只剩下了。 前言 和MySQL數(shù)據(jù)庫相比MongoDB的管理工具其實(shí)不算多,除了MongoVUE客戶端以外想要通過類似phpMyAdmin一樣通過Web管理MongoDB的數(shù)據(jù)庫應(yīng)該也只剩下RockMongo了。 和phpMyAdmin一樣好用的MongoDB管理工具 更新記錄 2015年10月...

    lookSomeone 評(píng)論0 收藏0
  • LTMP手動(dòng)編譯安裝以及自動(dòng)部署實(shí)踐

    摘要:我自己是從商業(yè)化環(huán)境走出來的,對(duì)于開源的部署方案也是在一點(diǎn)一點(diǎn)摸索,我相信其中也必然包含某些坑爹的配置。設(shè)置為表示當(dāng)經(jīng)常出現(xiàn)錯(cuò)誤時(shí)可以嘗試更改此選項(xiàng)。設(shè)置環(huán)境變量添加服務(wù)設(shè)置開機(jī)自動(dòng)啟動(dòng)服務(wù)配置其它擴(kuò)展都可以動(dòng)態(tài)添加,沒事的 showImg(//i.v2ex.co/Up79Hq7l.jpeg); 前言 現(xiàn)在很多朋友都了解或者已經(jīng)在使用LNMP架構(gòu),一般可以理解為L(zhǎng)inux Shel...

    HelKyle 評(píng)論0 收藏0

發(fā)表評(píng)論

0條評(píng)論

閱讀需要支付1元查看
<